From 4ea3d0c0c898884a4540f44107c29b96222f97bd Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Thu, 4 Nov 2021 18:29:49 +0100
Subject: [PATCH] scss: introduce $cell-entry-border instead
 $cell-entry-border-color (#58397)

---
 help/fr/misc-scss.page                      | 4 ++--
 static/ac-versailles/_vars.scss             | 2 +-
 static/cap-atlantique/_custom.scss          | 2 +-
 static/cinor-2021/_vars.scss                | 4 ++--
 static/cinor/_vars.scss                     | 2 +-
 static/clermont-ici/_vars.scss              | 2 +-
 static/essonne-cd91/_vars.scss              | 2 +-
 static/fontenay-sous-bois-2018/_vars.scss   | 2 +-
 static/gpseo/_vars.scss                     | 4 ++--
 static/grandlyon-sau/_vars.scss             | 2 +-
 static/grenoble-metropole-2019/_vars.scss   | 3 +--
 static/haguenau/_vars.scss                  | 2 +-
 static/haute-garonne-cd31/_vars.scss        | 2 +-
 static/hautes-alpes-cd05-2020/_vars.scss    | 4 ++--
 static/includes/_cells.scss                 | 9 +++++----
 static/isere-cd38/_vars.scss                | 4 ++--
 static/la-reunion-region/_vars.scss         | 4 ++--
 static/la-rochelle/_vars.scss               | 2 +-
 static/lambersart/_vars.scss                | 4 ++--
 static/marseille/_vars.scss                 | 2 +-
 static/meuse-cd55/_vars.scss                | 4 ++--
 static/meyzieu-2018/_vars.scss              | 2 +-
 static/montreuil/_vars.scss                 | 2 +-
 static/portal-agent/css/agent-portal.scss   | 4 ++--
 static/roannais-icitoyen/_vars.scss         | 4 ++--
 static/sables-d-olonne/_vars.scss           | 4 ++--
 static/saone-et-loire-cd71-2019/_vars.scss  | 2 +-
 static/thonon-agglomeration-2021/_vars.scss | 2 +-
 static/thonon-agglomeration/_vars.scss      | 4 ++--
 static/tours-metropole/_custom.scss         | 2 +-
 static/venissieux/_vars.scss                | 2 +-
 static/villeurbanne-intranet/_vars.scss     | 2 +-
 32 files changed, 48 insertions(+), 48 deletions(-)

diff --git a/help/fr/misc-scss.page b/help/fr/misc-scss.page
index cd0ab624..fa82f651 100644
--- a/help/fr/misc-scss.page
+++ b/help/fr/misc-scss.page
@@ -782,8 +782,8 @@ paramètre, la deuxième sa description et la troisième la valeur par défaut.
  </tr>
  <tr>
   <td><p><code>$cell-entry-border-color</code></p></td>
-  <td><p>Couleur de la bordure des éléments de cellule</p></td>
-  <td><p><var>#ccc</var></p></td>
+  <td><p>Bordure des éléments de cellule</p></td>
+  <td><p><var>1px solid #ccc</var></p></td>
  </tr>
  <tr>
   <td><p><code>$cell-entry-font-weight</code></p></td>
diff --git a/static/ac-versailles/_vars.scss b/static/ac-versailles/_vars.scss
index 1dbadab0..1a4d4267 100644
--- a/static/ac-versailles/_vars.scss
+++ b/static/ac-versailles/_vars.scss
@@ -35,7 +35,7 @@ $widget-custom-radio-checkbox: true;
 $widget-unique-checkbox-position: left;
 
 $cell-border: none;
-$cell-entry-border-color: #cecac4;
+$cell-entry-border: 1px solid #cecac4;
 $cell-entry-hover-background: inherit;
 
 $notification_info_color: #79adc2;
diff --git a/static/cap-atlantique/_custom.scss b/static/cap-atlantique/_custom.scss
index 076942a3..79c48697 100644
--- a/static/cap-atlantique/_custom.scss
+++ b/static/cap-atlantique/_custom.scss
@@ -145,7 +145,7 @@ div#nav {
 		&.has-asset-picture picture {
 			display: block;
 			text-align: center;
-			border-bottom: 1px solid $cell-entry-border-color;
+			border-bottom: $cell-entry-border;
 			img {
 				display: inline-block;
 			}
diff --git a/static/cinor-2021/_vars.scss b/static/cinor-2021/_vars.scss
index cd5503d7..ed2111b3 100644
--- a/static/cinor-2021/_vars.scss
+++ b/static/cinor-2021/_vars.scss
@@ -53,7 +53,7 @@ $title-color: $font-color;
 $cell-border: none;
 $cell-title-cover-border: false;
 
-$cell-entry-border-color: $green-yellow;
+$cell-entry-border: 1px solid $green-yellow;
 $cell-entry-hover-background: $green-yellow-light;
 $cell-entry-hover-color: black;
 $cell-entry-hover-effect: bottom-to-top;
@@ -76,4 +76,4 @@ $buttons-order: previous, cancel, submit;
 $footer-background: #0E2327;
 $footer-color: white;
 $footer-link-color: white;
-$footer-menucell-separator: 1px solid $footer-color;
\ No newline at end of file
+$footer-menucell-separator: 1px solid $footer-color;
diff --git a/static/cinor/_vars.scss b/static/cinor/_vars.scss
index 54d70ae3..8f992bdc 100644
--- a/static/cinor/_vars.scss
+++ b/static/cinor/_vars.scss
@@ -43,7 +43,7 @@ $cell-background: #eee;
 $cell-border: none;
 $cell-title-cover-border: false;
 
-$cell-entry-border-color: white;
+$cell-entry-border: 1px solid white;
 $cell-entry-hover-background: change-color($violet, $alpha: 0.1);
 $cell-entry-hover-color: black;
 $cell-entry-hover-effect: bottom-to-top;
diff --git a/static/clermont-ici/_vars.scss b/static/clermont-ici/_vars.scss
index dbbfd858..7a67e7a1 100644
--- a/static/clermont-ici/_vars.scss
+++ b/static/clermont-ici/_vars.scss
@@ -65,7 +65,7 @@ $carrousel-navigation-bullet-color: white;
 $cell-border: 1px solid $font-color;
 $cell-title-cover-border: false;
 $cell-entry-color: $font-color;
-$cell-entry-border-color: $gray-dark;
+$cell-entry-border: 1px solid $gray-dark;
 $cell-entry-hover-background: $beige;
 
 $button-background: $orange;
diff --git a/static/essonne-cd91/_vars.scss b/static/essonne-cd91/_vars.scss
index 9313da8c..79f89507 100644
--- a/static/essonne-cd91/_vars.scss
+++ b/static/essonne-cd91/_vars.scss
@@ -33,7 +33,7 @@ $button-background: $primary-color;
 $buttons-order: previous (grow),cancel (grow),submit;
 
 $cell-border: none;
-$cell-entry-border-color: white;
+$cell-entry-border: 1px solid white;
 $cell-entry-hover-effect: left-to-right;
 $cell-entry-hover-background: $primary-color-light-grayish;
 
diff --git a/static/fontenay-sous-bois-2018/_vars.scss b/static/fontenay-sous-bois-2018/_vars.scss
index a62fdada..47a2b0a2 100644
--- a/static/fontenay-sous-bois-2018/_vars.scss
+++ b/static/fontenay-sous-bois-2018/_vars.scss
@@ -12,7 +12,7 @@ $nav-item-hover-background: $primary-color;
 $nav-border-color: transparent;
 
 $cell-border: none;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 $cell-entry-hover-background: transparent;
 $cell-title-cover-border: false;
 
diff --git a/static/gpseo/_vars.scss b/static/gpseo/_vars.scss
index 8b44eba9..e85fe6ad 100644
--- a/static/gpseo/_vars.scss
+++ b/static/gpseo/_vars.scss
@@ -44,7 +44,7 @@ $cell-title-cover-border: false;
 $cell-image-position: top;
 $cell-image-padding: 0 0 0 1rem;
 $cell-background: $gray;
-$cell-entry-border-color: none;
+$cell-entry-border: none;
 $cell-entry-color: $font-color;
 $cell-entry-hover-color: $blue;
 
@@ -65,4 +65,4 @@ $wcs-step-current-border-bottom: 1px solid $font-color;
 
 
 $footer-background: $black;
-$footer-color: white;
\ No newline at end of file
+$footer-color: white;
diff --git a/static/grandlyon-sau/_vars.scss b/static/grandlyon-sau/_vars.scss
index 8e715914..cdc8cdf8 100644
--- a/static/grandlyon-sau/_vars.scss
+++ b/static/grandlyon-sau/_vars.scss
@@ -29,7 +29,7 @@ $cell-border: 0px solid transparent;
 $cell-entry-hover-color: #FFFFFF;
 $cell-entry-hover-effect: top-to-bottom;
 $cell-entry-hover-background: #999999;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 $sidebar-width: 250px;
 $menucell-hover-border: 5px solid #999;
 
diff --git a/static/grenoble-metropole-2019/_vars.scss b/static/grenoble-metropole-2019/_vars.scss
index bbeaff9a..eb14529d 100644
--- a/static/grenoble-metropole-2019/_vars.scss
+++ b/static/grenoble-metropole-2019/_vars.scss
@@ -39,11 +39,10 @@ $nav-item-selected-background: #000000;
 $footer-background: #000;
 $footer-color: $primary-color;
 
-$cell-entry-border-color: #000;
 $cell-background: transparent;
 $cell-border: 0px solid transparent;
 $cell-entry-hover-background: $primary-color;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 
 $sidebar-width: auto;
 
diff --git a/static/haguenau/_vars.scss b/static/haguenau/_vars.scss
index bd725e44..03d2f1bc 100644
--- a/static/haguenau/_vars.scss
+++ b/static/haguenau/_vars.scss
@@ -55,7 +55,7 @@ $cell-border: none;
 $cell-title-cover-border: false;
 $cell-entry-font-weight: 600;
 $cell-entry-color: $blue;
-$cell-entry-border-color: $blue;
+$cell-entry-border: 1px solid $blue;
 $cell-entry-hover-color: white;
 $cell-entry-hover-background: $blue;
 
diff --git a/static/haute-garonne-cd31/_vars.scss b/static/haute-garonne-cd31/_vars.scss
index efe195b0..3b06816d 100644
--- a/static/haute-garonne-cd31/_vars.scss
+++ b/static/haute-garonne-cd31/_vars.scss
@@ -46,7 +46,7 @@ $carrousel-text-position: bottom left;
 $carrousel-navigation: none;
 
 $cell-entry-hover-background: white;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 $cell-image-position: top;
 $cell-image-padding: 0;
 $cell-title-cover-border: false;
diff --git a/static/hautes-alpes-cd05-2020/_vars.scss b/static/hautes-alpes-cd05-2020/_vars.scss
index 4df33cf0..4d15167a 100644
--- a/static/hautes-alpes-cd05-2020/_vars.scss
+++ b/static/hautes-alpes-cd05-2020/_vars.scss
@@ -40,7 +40,7 @@ $cell-background: $gray-light;
 $cell-border: none;
 $cell-entry-color: $font-color;
 $cell-entry-hover-background: $orange-light;
-$cell-entry-border-color: $blue-light;
+$cell-entry-border: 1px solid $blue-light;
 
 $button-background: $orange;
 $button-hover-background: $orange-light;
@@ -63,4 +63,4 @@ $or-separator: false;
 $footer-background: white;
 $footer-color: $font-color;
 $footer-menucell-separator: 1px solid;
-// $footer-full-width-background:
\ No newline at end of file
+// $footer-full-width-background:
diff --git a/static/includes/_cells.scss b/static/includes/_cells.scss
index 7da8afe4..b33196f8 100644
--- a/static/includes/_cells.scss
+++ b/static/includes/_cells.scss
@@ -9,6 +9,7 @@ $cell-title-cover-border: true !default;
 $cell-entry-color: $link-color !default;
 $cell-entry-font-weight: normal !default;
 $cell-entry-border-color: #ccc !default;
+$cell-entry-border: 1px solid $cell-entry-border-color !default;
 $cell-entry-hover-color: inherit !default;
 $cell-entry-hover-background: #eee !default;
 
@@ -168,7 +169,7 @@ div.wcscurrentformscell ul {
 	z-index: 0;
 
 	& > li:not(:last-child) {
-		border-bottom: 1px solid $cell-entry-border-color;
+		border-bottom: $cell-entry-border;
 	}
 	& > li > a {
 		display: flex;
@@ -338,7 +339,7 @@ div.cell {
 			padding-bottom: 0.7em;
 		}
 		ul > li:last-child {
-			border-bottom: 1px solid $cell-entry-border-color;
+			border-bottom: $cell-entry-border;
 
 			@if is-positive-number($cell-border-radius) {
 				> a {
@@ -374,7 +375,7 @@ div.cell {
 
 div.menucell li li {
 	border-bottom: none;
-	border-top: 1px solid $cell-entry-border-color;
+	border-top: $cell-entry-border;
 	a {
 		padding-left: 3em;
 		font-size: 90%;
@@ -490,7 +491,7 @@ div.cell div.loading.error-loading::after {
 	}
 	&--item {
 		padding: 1rem;
-		border-bottom: 1px solid $cell-entry-border-color;
+		border-bottom: $cell-entry-border;
 		display: flex;
 		flex-wrap: wrap;
 		align-items: baseline;
diff --git a/static/isere-cd38/_vars.scss b/static/isere-cd38/_vars.scss
index e952203b..f15e49e5 100644
--- a/static/isere-cd38/_vars.scss
+++ b/static/isere-cd38/_vars.scss
@@ -63,7 +63,7 @@ $cell-title-cover-border: false;
 $cell-background: transparent;
 $cell-entry-color: $gray-dark;
 $cell-entry-hover-color: black;
-$cell-entry-border-color: $cyan-dark;
+$cell-entry-border: 1px solid $cyan-dark;
 $cell-entry-hover-background: $cyan-xlight;
 
 $button-background: $cyan-dark;
@@ -76,4 +76,4 @@ $notification_info_color: $cyan-dark;
 
 $widget-unique-checkbox-position: left;
 
-$footer-background: $cyan-dark;
\ No newline at end of file
+$footer-background: $cyan-dark;
diff --git a/static/la-reunion-region/_vars.scss b/static/la-reunion-region/_vars.scss
index 70e814a8..39f21809 100644
--- a/static/la-reunion-region/_vars.scss
+++ b/static/la-reunion-region/_vars.scss
@@ -45,7 +45,7 @@ $cell-border: 1px solid $light-gray;
 $cell-entry-hover-color: $primary-color;
 $cell-entry-hover-background: $pale-blue;
 $cell-entry-hover-color: black;
-$cell-entry-border-color: white;
+$cell-entry-border: 1px solid white;
 $cell-background: $xlight-gray;
 $cell-image-padding: 0;
 
@@ -70,4 +70,4 @@ $widget-border: 1px solid $gray;
 $widget-focus-border: 1px solid $primary-color;
 $widget-focus-color: $primary-color;
 
-// $widget-border: 2px solid $light-gray;
\ No newline at end of file
+// $widget-border: 2px solid $light-gray;
diff --git a/static/la-rochelle/_vars.scss b/static/la-rochelle/_vars.scss
index 12dab965..ee9e51fd 100644
--- a/static/la-rochelle/_vars.scss
+++ b/static/la-rochelle/_vars.scss
@@ -31,7 +31,7 @@ $cell-title-cover-border: false;
 $cell-entry-color: $font-color;
 $cell-entry-hover-color: black;
 $cell-entry-hover-background: #F2F2F2;
-$cell-entry-border-color: lighten(#e2e0e1, 20%);
+$cell-entry-border: 1px solid lighten(#e2e0e1, 20%);
 $cell-border-radius: 0px;
 
 $widget-border: 1px solid #cccccc;
diff --git a/static/lambersart/_vars.scss b/static/lambersart/_vars.scss
index e5d47dec..94b33c11 100644
--- a/static/lambersart/_vars.scss
+++ b/static/lambersart/_vars.scss
@@ -35,7 +35,7 @@ $title-border-bottom: 1px solid $green;
 
 $cell-title-cover-border: false;
 $cell-border: 1px solid $gray-light;
-$cell-entry-border-color: $green;
+$cell-entry-border: 1px solid $green;
 $cell-entry-hover-color: white;
 $cell-entry-hover-background: $green;
 $cell-entry-font-weight: 500;
@@ -47,4 +47,4 @@ $button-color: white;
 $widget-border: 1px solid $green;
 $widget-focus-border: 1px solid $blue;
 
-$footer-color: $font-color;
\ No newline at end of file
+$footer-color: $font-color;
diff --git a/static/marseille/_vars.scss b/static/marseille/_vars.scss
index ec68874b..e223ea6d 100644
--- a/static/marseille/_vars.scss
+++ b/static/marseille/_vars.scss
@@ -57,7 +57,7 @@ $cell-entry-color: $font-color;
 $cell-entry-font-weight: 400;
 $cell-entry-hover-background: transparent;
 $cell-entry-hover-color: $link-color;
-$cell-entry-border-color: $sep-color;
+$cell-entry-border: 1px solid $sep-color;
 
 $title-background: transparent;
 $title-color: $blue-xdark;
diff --git a/static/meuse-cd55/_vars.scss b/static/meuse-cd55/_vars.scss
index 43cea418..536c1e65 100644
--- a/static/meuse-cd55/_vars.scss
+++ b/static/meuse-cd55/_vars.scss
@@ -55,7 +55,7 @@ $cell-background: transparent;
 $cell-image-position: top;
 $cell-image-padding: 0;
 $cell-entry-hover-background: lighten($light-red, 25%);
-$cell-entry-border-color: lighten($desaturated-blue, 20%);
+$cell-entry-border: 1px solid lighten($desaturated-blue, 20%);
 
 $button-background: $light-red;
 $button-color: $dark-desaturated-blue;
@@ -83,4 +83,4 @@ $wcs-step-marker-tie-width: 2px;
 $wcs-step-current-marker-enlarge: 1.4;
 
 $footer-background: $dark-desaturated-blue;
-$footer-color: white;
\ No newline at end of file
+$footer-color: white;
diff --git a/static/meyzieu-2018/_vars.scss b/static/meyzieu-2018/_vars.scss
index bb800f07..7c129999 100644
--- a/static/meyzieu-2018/_vars.scss
+++ b/static/meyzieu-2018/_vars.scss
@@ -20,7 +20,7 @@ $sidebar-position: right;
 $cell-entry-hover-background: transparent;
 $cell-entry-color: #333;
 $cell-border: 0;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 
 $button-background: $primary-color;
 
diff --git a/static/montreuil/_vars.scss b/static/montreuil/_vars.scss
index a3d818a5..eaf9c611 100644
--- a/static/montreuil/_vars.scss
+++ b/static/montreuil/_vars.scss
@@ -35,7 +35,7 @@ $widget-focus-border: 1px solid $secondary-color;
 
 $cell-border: 1px solid $secondary-color;
 $cell-image-position: top;
-$cell-entry-border-color: $secondary-color;
+$cell-entry-border: 1px solid $secondary-color;
 
 $button-background: $primary-color;
 
diff --git a/static/portal-agent/css/agent-portal.scss b/static/portal-agent/css/agent-portal.scss
index e9c3dc6e..3b0c3b33 100644
--- a/static/portal-agent/css/agent-portal.scss
+++ b/static/portal-agent/css/agent-portal.scss
@@ -3,7 +3,7 @@ $primary-color: #386ede;
 $secondary-color: #00d6eb;
 
 $cell-entry-color: #333;
-$cell-entry-border-color: #ccc;
+$cell-entry-border: 1px solid #ccc;
 $cell-entry-hover-color: $cell-entry-color;
 $cell-entry-hover-background: #eee;
 $mobile-limit: 760px;
@@ -173,7 +173,7 @@ div.links-list {
 		z-index: 0;
 		& > li {
 			color: $cell-entry-color;
-			border-bottom: 1px solid $cell-entry-border-color;
+			border-bottom: $cell-entry-border;
 			position: relative;
 
 			> h4 { // group titles
diff --git a/static/roannais-icitoyen/_vars.scss b/static/roannais-icitoyen/_vars.scss
index af6620e2..b1985fe0 100644
--- a/static/roannais-icitoyen/_vars.scss
+++ b/static/roannais-icitoyen/_vars.scss
@@ -119,7 +119,7 @@ $nav-mobile-bottom-bar-item-hover-color: white;
 
 $cell-border: none;
 $cell-entry-color: $gray;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 
 $carrousel-text-position: bottom left;
 $carrousel-navigation-bullet-size: 15px;
@@ -153,4 +153,4 @@ $wcs-step-current-marker-background: $primary-color;
 
 $footer-background: $font-color;
 $footer-color: #fff;
-$footer-menucell-separator: 1px solid;
\ No newline at end of file
+$footer-menucell-separator: 1px solid;
diff --git a/static/sables-d-olonne/_vars.scss b/static/sables-d-olonne/_vars.scss
index c6a38dbc..592c89df 100644
--- a/static/sables-d-olonne/_vars.scss
+++ b/static/sables-d-olonne/_vars.scss
@@ -42,7 +42,7 @@ $cell-title-cover-border: false;
 $cell-border-radius: 5px;
 
 $cell-entry-font-weight: 600;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 $cell-entry-hover-color: $violet;
 $cell-entry-hover-background: transparent;
 $cell-open-foldable-icon: url(img/cell-open-foldable-icon.svg);
@@ -67,4 +67,4 @@ $wcs-step-current-color: white;
 $wcs-steps-spacing: 0.7rem;
 
 $footer-background: white;
-$footer-color: $violet;
\ No newline at end of file
+$footer-color: $violet;
diff --git a/static/saone-et-loire-cd71-2019/_vars.scss b/static/saone-et-loire-cd71-2019/_vars.scss
index 6327d523..3f401631 100644
--- a/static/saone-et-loire-cd71-2019/_vars.scss
+++ b/static/saone-et-loire-cd71-2019/_vars.scss
@@ -19,7 +19,7 @@ $nav-item-hover-background: $primary-color;
 $nav-border-color: transparent;
 
 $cell-border: none;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 $cell-entry-hover-background: #eef;
 $cell-entry-hover-effect: left-to-right;
 $cell-title-cover-border: false;
diff --git a/static/thonon-agglomeration-2021/_vars.scss b/static/thonon-agglomeration-2021/_vars.scss
index 039d6afa..c8cb3e3a 100644
--- a/static/thonon-agglomeration-2021/_vars.scss
+++ b/static/thonon-agglomeration-2021/_vars.scss
@@ -63,7 +63,7 @@ $cell-border-radius: 12px;
 $cell-border: 1px solid $gray-light;
 $cell-title-cover-border: false;
 $cell-image-position: top;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 $cell-entry-color: $font-color;
 $cell-entry-hover-color: black;
 $cell-entry-font-weight: 500;
diff --git a/static/thonon-agglomeration/_vars.scss b/static/thonon-agglomeration/_vars.scss
index 4b0a3b7d..880c5248 100644
--- a/static/thonon-agglomeration/_vars.scss
+++ b/static/thonon-agglomeration/_vars.scss
@@ -39,7 +39,7 @@ $widget-custom-radio-checkbox: true;
 $widget-unique-checkbox-position: left;
 
 $cell-border: none; // 1px solid #cecac4;
-$cell-entry-border-color: #cecac4;
+$cell-entry-border: 1px solid #cecac4;
 $cell-entry-hover-background: inherit;
 
 $notification_info_color: #79adc2;
@@ -50,4 +50,4 @@ $notification_error_color: #db635c;
 
 $wcs-step-border-bottom: none;
 $wcs-step-current-color: black;
-$wcs-step-current-marker-background: #fec307;
\ No newline at end of file
+$wcs-step-current-marker-background: #fec307;
diff --git a/static/tours-metropole/_custom.scss b/static/tours-metropole/_custom.scss
index 97692ef7..37822d57 100644
--- a/static/tours-metropole/_custom.scss
+++ b/static/tours-metropole/_custom.scss
@@ -251,7 +251,7 @@ div#footer-wrapper {
 			}
 		}
 		ul {
-			border: 1px solid $cell-entry-border-color;
+			border: $cell-entry-border;
 			border-top: 0;
 
 			&:last-child {
diff --git a/static/venissieux/_vars.scss b/static/venissieux/_vars.scss
index 5514db15..f9efff0e 100644
--- a/static/venissieux/_vars.scss
+++ b/static/venissieux/_vars.scss
@@ -12,7 +12,7 @@ $font-color: #2c292a;
 $link-color: #3999b0;
 
 $cell-border: none;
-$cell-entry-border-color: transparent;
+$cell-entry-border: 1px solid transparent;
 $cell-entry-hover-background: transparent;
 $cell-title-cover-border: false;
 $title-background: transparent;
diff --git a/static/villeurbanne-intranet/_vars.scss b/static/villeurbanne-intranet/_vars.scss
index 138129eb..1256f5f9 100644
--- a/static/villeurbanne-intranet/_vars.scss
+++ b/static/villeurbanne-intranet/_vars.scss
@@ -40,7 +40,7 @@ $cell-border: none;
 $cell-entry-color: $cyan-dark;
 $cell-entry-hover-color: $red;
 $cell-entry-hover-background: $cyan-xlight;
-$cell-entry-border-color: $gray;
+$cell-entry-border: 1px solid $gray;
 
 $button-background: $cyan-dark;
 $button-hover-background: $cyan;
-- 
2.20.1